Index: roarclients/roarctl.c
===================================================================
--- roarclients/roarctl.c	(revision 6052)
+++ roarclients/roarctl.c	(revision 0)
@@ -603,606 +90,28 @@
 
  for (i = 0; i < num; i++) {
-  display_stream(con, id[i]);
- }
-}
-
-void display_stream (struct roar_connection * con, int id) {
- char chanmap[ROAR_MAX_CHANNELS];
- struct roar_stream s;
- struct roar_stream_info info;
- char buffer[1024];
- char * flags = buffer;
- char * name  = buffer;
- char * infotext;
- const char * mime;
- size_t len;
-
- printf("stream %i:\n", id);
- if ( roar_get_stream(con, &s, id) == -1 ) {
-  fprintf(stderr, "Error: can not get stream info\n");
-  return;
- }
- printf("Stream direction      : %s\n", roar_dir2str(s.dir));
-
- if ( roar_stream_get_name(con, &s, name, sizeof(buffer)) == 0 )
-  printf("Stream name           : %s\n", name);
-
- if ( (int)s.pos_rel_id == -1 ) {
-  printf("Relativ position id   : none (stream not synchronized)\n");
- } else if ( (int)s.pos_rel_id == id ) {
-  printf("Relativ position id   : %i (self synchronized)\n", s.pos_rel_id);
- } else {
-  printf("Relativ position id   : %i (synchronized)\n", s.pos_rel_id);
- }
- if ( g_verbose > 1 && s.pos != (uint32_t)-1 ) {
-  if ( s.info.rate && s.info.channels ) {
-   printf("Position              : %lu S (%.3fs)\n", (unsigned long int) s.pos,
-                                   (float)s.pos/(s.info.rate*s.info.channels));
-  } else {
-   printf("Position              : %lu S\n", (unsigned long int) s.pos);
-  }
- }
-
- switch (s.dir) {
-  case ROAR_DIR_MIDI_IN:
-  case ROAR_DIR_MIDI_OUT:
-    infotext = " ticks/s";
-   break;
-  case ROAR_DIR_LIGHT_IN:
-  case ROAR_DIR_LIGHT_OUT:
-    infotext = " updates/s";
-   break;
-  default:
-    infotext = " Hz";
- }
- if ( s.info.rate )
-  printf("Stream sample rate    : %i%s\n", s.info.rate, infotext);
- if ( s.info.bits )
-  printf("Stream bits           : %i\n", s.info.bits);
- if ( s.info.channels )
-  printf("Stream channels       : %i\n", s.info.channels);
-
- mime = roar_codec2mime(s.info.codec);
- printf("Stream codec          : %2i (%s%s%s%s)\n", s.info.codec, roar_codec2str(s.info.codec),
-                                      s.info.codec == ROAR_CODEC_DEFAULT ? " native" : "",
-                                      mime == NULL ? "" : " mimetype:",
-                                      mime == NULL ? "" : mime
-                                     );
- if ( roar_stream_get_info(con, &s, &info) != -1 ) {
-  if ( info.codec != s.info.codec ) {
-   mime = roar_codec2mime(info.codec);
-   printf("Streamed codec        : %2i (%s%s%s%s)\n", info.codec, roar_codec2str(info.codec),
-                                      info.codec == ROAR_CODEC_DEFAULT ? " native" : "",
-                                      mime == NULL ? "" : " mimetype:",
-                                      mime == NULL ? "" : mime
-                                     );
-  }
-
-  if ( g_verbose ) {
-   if ( info.block_size )
-    printf("Stream block size     : %i Byte\n", info.block_size);
-
-   printf("Underruns pre/post    : %i/%i\n",   info.pre_underruns, info.post_underruns);
-   if ( g_verbose > 1 )
-    printf("Stream delay          : %ims (%.2fm)\n",   (int)info.delay/1000, (info.delay*(float)_SPEED_OF_SOUND));
-
-   if ( g_verbose > 1 )
-    printf("Stream mixer          : %i\n",   info.mixer);
-
-   if ( g_verbose > 1 )
-    printf("Stream state          : %s\n",   roar_streamstate2str(info.state));
-
-   if ( g_verbose > 1 )
-    printf("Stream role           : %s\n",   roar_role2str(info.role));
-
-   *flags = 0;
-#define _strcat(dst,src) roar_mm_strlcat((dst),(src), sizeof(buffer))
-   if ( info.flags & ROAR_FLAG_PRIMARY )
-    _strcat(flags, "primary ");
-   if ( info.flags & ROAR_FLAG_SYNC )
-    _strcat(flags, "sync ");
-   if ( info.flags & ROAR_FLAG_OUTPUT )
-    _strcat(flags, "output ");
-   if ( info.flags & ROAR_FLAG_SOURCE )
-    _strcat(flags, "source ");
-   if ( info.flags & ROAR_FLAG_META )
-    _strcat(flags, "meta ");
-   if ( info.flags & ROAR_FLAG_AUTOCONF )
-    _strcat(flags, "autoconf ");
-   if ( info.flags & ROAR_FLAG_CLEANMETA )
-    _strcat(flags, "cleanmeta ");
-   if ( info.flags & ROAR_FLAG_HWMIXER )
-    _strcat(flags, "hwmixer ");
-   if ( info.flags & ROAR_FLAG_PAUSE )
-    _strcat(flags, "pause ");
-   if ( info.flags & ROAR_FLAG_MUTE )
-    _strcat(flags, "mute ");
-   if ( info.flags & ROAR_FLAG_MMAP )
-    _strcat(flags, "mmap ");
-   if ( info.flags & ROAR_FLAG_ANTIECHO )
-    _strcat(flags, "antiecho ");
-   if ( info.flags & ROAR_FLAG_VIRTUAL )
-    _strcat(flags, "virtual ");
-   if ( info.flags & ROAR_FLAG_RECSOURCE )
-    _strcat(flags, "recsource ");
-   if ( info.flags & ROAR_FLAG_PASSMIXER )
-    _strcat(flags, "passmixer ");
-   if ( info.flags & ROAR_FLAG_PRETHRU )
-    _strcat(flags, "prethru ");
-   if ( info.flags & ROAR_FLAG_IMMUTABLE )
-    _strcat(flags, "immutable ");
-   if ( info.flags & ROAR_FLAG_ENHANCE )
-    _strcat(flags, "enhance ");
-   if ( info.flags & ROAR_FLAG_SINGLESINK )
-    _strcat(flags, "singlesink ");
-#undef _strcat
-
-   printf("Flags                 : %s\n", flags);
-  }
- }
-
- if ( g_verbose && (s.info.channels != 0 && s.info.channels <= ROAR_MAX_CHANNELS) ) {
-  len = ROAR_MAX_CHANNELS;
-  if ( roar_stream_get_chanmap(con, &s, chanmap, &len) == -1 ) {
-   fprintf(stderr, "Error: can not get stream channel map\n");
-  } else {
-   if ( roardsp_chanlist2str(chanmap, len, buffer, 1024) == -1 ) {
-    fprintf(stderr, "Error: can not convert channel map into string\n");
-   } else {
-    printf("Channel Map           : %s\n", buffer);
-   }
-  }
- }
-
- if ( s.dir != ROAR_DIR_THRU ) {
-  if ( s.info.channels != 0 && s.info.channels <= ROAR_MAX_CHANNELS ) {
-   display_mixer(con, id);
-  }
-  show_meta_all(con, id);
- }
-}
-
-int display_mixer (struct roar_connection * con, int stream) {
- struct roar_stream_rpg rpg;
- struct roar_mixer_settings mixer;
- struct roar_stream s;
- int channels;
- int i;
- float fs;
-
- if ( roar_get_vol(con, stream, &mixer, &channels) == -1 ) {
-  fprintf(stderr, "Error: can not get stream mixer info for stream %i\n", stream);
-  return -1;
- }
-
- roar_stream_new_by_id(&s, stream);
- if ( roar_stream_get_rpg(con, &s, &rpg) != -1 ) {
-  printf("ReplayGain Mode       : %s\n", roar_rpgmode2str(rpg.mode));
- }
-
-#ifdef ROAR_HAVE_LIBM
-#define _DB ", %.2fdB"
-#else
-#define _DB ""
-#endif
-
- fs = (float)mixer.scale / 100.;
-
- if ( channels ) { // we hide RPG info for zero-channel streams
-  printf("Mixer ReplayGain      : %i/%i (%.2f%%" _DB ")\n", mixer.rpg_mul, mixer.rpg_div,
-                                                          100.*(float)mixer.rpg_mul/((float)mixer.rpg_div)
-#ifdef ROAR_HAVE_LIBM
-                           , 20*log10f((float)mixer.rpg_mul/(float)mixer.rpg_div)
-#endif
-        );
- }
-
- for (i = 0; i < channels; i++)
-  printf("Mixer volume chan %2i  : %i/%i (%.2f%%" _DB ")\n", i, mixer.mixer[i], mixer.scale,
-                           (float)mixer.mixer[i]/fs
-#ifdef ROAR_HAVE_LIBM
-                          , 20*log10f((float)mixer.mixer[i]/(float)mixer.scale)
-#endif
-        );
-
- return 0;
-}
-
-static unsigned int set_mixer_parse_volume (char * k, int len, uint16_t scale) {
- float fs = scale;
-
- switch (k[len - 1]) {
-  case '%':
-    k[len - 1] = 0;
-    return (atof(k)*fs)/100.;
-   break;
-#ifdef ROAR_HAVE_LIBM
-  case 'b':
-  case 'B':
-    // TODO: can we hanle the error better?
-    if ( len < 2 )
-     return 0;
-
-    k[len - 2] = 0;
-    return powf(10, atof(k)/20.f)*fs;
-   break;
-#endif
- }
-
- return atoi(k);
-}
-
-int set_mixer (struct roar_connection * con, int * cur, int max, char * arg[]) {
- uint16_t scale = 65535;
- int chans = 0;
- int id;
- int i;
- int len;
- int old_chans;
- char * k;
- struct roar_mixer_settings mixer;
- struct roar_mixer_settings old_mixer;
- int mode = ROAR_SET_VOL_ALL;
-
- if (*cur + 2 > max)
-  return -1;
-
- id = atoi(arg[++(*cur)]);
-
- k = arg[++(*cur)];
-
- if ( !strcmp(arg[*cur + 1], "scale") ) {
-  (*cur)++; // 'scale'
-  (*cur)++;
-  scale = set_mixer_parse_volume(arg[*cur], strlen(arg[*cur]), 65535);
- }
-
- mixer.scale = scale;
-
- if ( roar_get_vol(con, id, &old_mixer, &old_chans) == -1 ) {
-  fprintf(stderr, "Error: can not get stream mixer info for stream %i\n", id);
-  return -1;
- }
-
- if ( strcmp(k, "mono") == 0 ) {
-  chans = 1;
-  mode  = ROAR_SET_VOL_UNMAPPED;
- } else if ( strcmp(k, "stereo") == 0 ) {
-  chans = 2;
-  mode  = ROAR_SET_VOL_UNMAPPED;
- } else {
-  chans = atoi(k);
- }
-
- // ensure most simple mode:
- if ( old_chans == chans && mode == ROAR_SET_VOL_UNMAPPED )
-  mode = ROAR_SET_VOL_ALL;
-
- if ( *cur + chans > max )
-  return -1;
-
- for (i = 0; i < chans; i++) {
-  k   = arg[++(*cur)];
-  len = strlen(k);
-
-  mixer.mixer[i] = set_mixer_parse_volume(k, len, scale);
- }
-
- if ( roar_set_vol(con, id, &mixer, chans, mode) == 0 )
-  return 0;
-
- // no fallback if already using ROAR_SET_VOL_ALL:
- if ( mode == ROAR_SET_VOL_ALL )
-  return -1;
-
- if ( roar_conv_volume(&mixer, &mixer, old_chans, chans) == -1 )
-  return -1;
-
- chans = old_chans;
- mode  = ROAR_SET_VOL_ALL;
-
- if ( roar_set_vol(con, id, &mixer, chans, mode) == 0 )
-  return 0;
-
- return -1;
-}
-
-
-int newvirtual (struct roar_connection * con, char *p_s, char *d_s, char *e_s, char *r_s, char *b_s, char *c_s) {
- struct roar_stream s;
- int dir    = roar_str2dir(d_s);
- int parent = atoi(p_s);
-
- ROAR_DBG("newvirtual(*): dir=%i, parent=%i", dir, parent);
-
- if ( roar_stream_new(&s, roar_str2rate(r_s), roar_str2channels(c_s), roar_str2bits(b_s), roar_str2codec(e_s)) == -1 )
-  return -1;
-
- return roar_simple_connect_virtual(con, &s, parent, dir);
-}
-
-int set_meta (struct roar_connection * con, int id, char * mode, char * type, char * val) {
- struct roar_meta   meta;
- struct roar_stream s;
- int mode_i = ROAR_META_MODE_SET;
-
- if ( roar_stream_new_by_id(&s, id) == -1 )
-  return -1;
-
-// printf("set_meta(*): mode='%s', type='%s', val='%s'\n", mode, type, val);
-
- if ( strcmp(mode, "add") == 0 ) {
-  mode_i = ROAR_META_MODE_ADD;
- }
-
- meta.type   = roar_meta_inttype(type);
- meta.value  = val;
- meta.key[0] = 0;
-
- if ( meta.type == -1 ) {
-  fprintf(stderr, "Error: unknown type: %s\n", type);
-  return -1;
- }
-
-// printf("D: type=%i, mode=%i\n", meta.type, mode_i);
-
- if ( roar_stream_meta_set(con, &s, mode_i, &meta) == -1 )
-  return -1;
-
- meta.type  = ROAR_META_TYPE_NONE;
- meta.value = NULL;
-
- return roar_stream_meta_set(con, &s, ROAR_META_MODE_FINALIZE, &meta);
-}
-
-int load_meta (struct roar_connection * con, int id, char * file) {
- struct roar_meta   meta;
- struct roar_stream s;
- int mode_i = ROAR_META_MODE_SET;
- FILE * in;
- char lion[1024];
- char * v;
-
- if ( roar_stream_new_by_id(&s, id) == -1 )
-  return -1;
-
- if ( (in = fopen(file, "r")) == NULL )
-  return -1;
-
- while (fgets(lion, 1024, in) != NULL) {
-  if ( (v = strtok(lion, "\r\n")) != NULL )
-   if ( (v = strtok(NULL, "\r\n")) != NULL )
-    *(v-1) = 0;
-
-  if ( (v = strstr(lion, "=")) == NULL ) {
-   fprintf(stderr, "Error: can not parse meta data lion: %s\n", lion);
+  printf("stream %i:\n", id[i]);
+  if ( roar_get_stream(con, &s, id[i]) == -1 ) {
+   fprintf(stderr, "Error: can not get stream info\n");
    continue;
   }
-
-  *v++ = 0;
-
-  meta.type   = roar_meta_inttype(lion);
-  meta.value  = v;
-  meta.key[0] = 0;
-
-  if ( meta.type == -1 ) {
-   fprintf(stderr, "Error: unknown type: %s\n", lion);
-   continue;
-  }
-
-  if ( roar_stream_meta_set(con, &s, mode_i, &meta) == -1 ) {
-   fclose(in);
-   return -1;
-  }
- }
-
- fclose(in);
-
- meta.type  = ROAR_META_TYPE_NONE;
- meta.value = NULL;
-
- return roar_stream_meta_set(con, &s, ROAR_META_MODE_FINALIZE, &meta);
-}
-
-int show_meta_type (struct roar_connection * con, int id, const char * type) {
- struct roar_meta   meta;
- struct roar_stream s;
-
- if ( roar_stream_new_by_id(&s, id) == -1 )
-  return -1;
-
- meta.type  = roar_meta_inttype(type);
-
- if ( meta.type == -1 ) {
-  fprintf(stderr, "Error: unknown type: %s\n", type);
-  return -1;
- }
-
- if ( roar_stream_meta_get(con, &s, &meta) == -1 )
-  return -1;
-
- printf("Meta %-17s: %s\n", roar_meta_strtype(meta.type), meta.value);
-
- roar_meta_free(&meta);
-
- return 0;
-}
-
-int show_meta_all (struct roar_connection * con, int id) {
- struct roar_stream s;
- int types[ROAR_META_MAX_PER_STREAM];
- int i;
- int len;
-
- if ( roar_stream_new_by_id(&s, id) == -1 )
-  return -1;
-
- if ( (len = roar_stream_meta_list(con, &s, types, ROAR_META_MAX_PER_STREAM)) == -1 )
-  return -1;
-
- for (i = 0; i < len; i++)
-  show_meta_type(con, id, roar_meta_strtype(types[i]));
-
- return 0;
-}
-
-int save_meta (struct roar_connection * con, int id, char * file) {
- struct roar_stream s;
- struct roar_meta   meta;
- int types[ROAR_META_MAX_PER_STREAM];
- int i;
- int len;
- FILE * out;
-
- if ( roar_stream_new_by_id(&s, id) == -1 )
-  return -1;
-
- if ( (len = roar_stream_meta_list(con, &s, types, ROAR_META_MAX_PER_STREAM)) == -1 )
-  return -1;
-
- if ( (out = fopen(file, "w")) == NULL )
-  return -1;
-
- for (i = 0; i < len; i++) {
-/*
-  show_meta_type(con, id, roar_meta_strtype(types[i]));
-*/
-  meta.type  = types[i];
-
-  if ( roar_stream_meta_get(con, &s, &meta) == -1 )
-   continue;
-
-//  printf("Meta %-17s: %s\n", roar_meta_strtype(meta.type), meta.value);
-
-  fprintf(out, "%s=%s\n", roar_meta_strtype(meta.type), meta.value);
-
-  roar_meta_free(&meta);
- }
-
- fclose(out);
-
- return 0;
-}
-
-int set_flags (struct roar_connection * con, int id, int action, char * flags) {
- uint32_t f = ROAR_FLAG_NONE;
- char * c;
- struct roar_stream s[1];
-
- if ( roar_stream_new_by_id(s, id) == -1 )
-  return -1;
-
- c = strtok(flags, ",");
- while (c != NULL) {
-  if ( !strcmp(c, "meta") ) {
-   f |= ROAR_FLAG_META;
-  } else if ( !strcmp(c, "primary") ) {
-   f |= ROAR_FLAG_PRIMARY;
-  } else if ( !strcmp(c, "sync") ) {
-   f |= ROAR_FLAG_SYNC;
-  } else if ( !strcmp(c, "cleanmeta") ) {
-   f |= ROAR_FLAG_CLEANMETA;
-  } else if ( !strcmp(c, "hwmixer") ) {
-   f |= ROAR_FLAG_HWMIXER;
-  } else if ( !strcmp(c, "pause") ) {
-   f |= ROAR_FLAG_PAUSE;
-  } else if ( !strcmp(c, "mute") ) {
-   f |= ROAR_FLAG_MUTE;
-  } else if ( !strcmp(c, "mmap") ) {
-   f |= ROAR_FLAG_MMAP;
-  } else if ( !strcmp(c, "antiecho") ) {
-   f |= ROAR_FLAG_ANTIECHO;
-  } else if ( !strcmp(c, "recsource") ) {
-   f |= ROAR_FLAG_RECSOURCE;
-  } else if ( !strcmp(c, "passmixer") ) {
-   f |= ROAR_FLAG_PASSMIXER;
-  } else if ( !strcmp(c, "virtual") ) {
-   f |= ROAR_FLAG_VIRTUAL;
-  } else if ( !strcmp(c, "prethru") ) {
-   f |= ROAR_FLAG_PRETHRU;
-  } else if ( !strcmp(c, "immutable") ) {
-   f |= ROAR_FLAG_IMMUTABLE;
-  } else if ( !strcmp(c, "enhance") ) {
-   f |= ROAR_FLAG_ENHANCE;
-  } else if ( !strcmp(c, "singlesink") ) {
-   f |= ROAR_FLAG_SINGLESINK;
-  } else {
-   fprintf(stderr, "Error: unknown flag: %s\n", c);
-   return -1;
-  }
-
-  c = strtok(NULL, ",");
- }
-
- return roar_stream_set_flags(con, s, f, action);
-}
-
-int set_role (struct roar_connection * con, int id, int role) {
- struct roar_stream s;
-
- if ( id == -1 )
-  return -1;
-
- if ( roar_stream_new_by_id(&s, id) == -1 )
-  return -1;
-
- if ( roar_stream_set_role(con, &s, role) == -1 )
-  return -1;
-
- return 0;
-}
-
-int show_aiprofile (const char * profile) {
- struct roar_audio_info info;
- const char * mime;
-
- if ( roar_profile2info(&info, profile) == -1 ) {
-  fprintf(stderr, "Error: unknown profile: %s\n", profile);
-  return -1;
- }
-
- mime = roar_codec2mime(info.codec);
-
- printf("Profile Name          : %s\n", profile);
-
- if ( info.rate )
-  printf("Profile sample rate   : %i\n", info.rate);
- if ( info.bits )
-  printf("Profile bits          : %i\n", info.bits);
- if ( info.channels )
-  printf("Profile channels      : %i\n", info.channels);
-
- printf("Profile codec         : %2i (%s%s%s%s)\n", info.codec, roar_codec2str(info.codec),
-                                       info.codec == ROAR_CODEC_DEFAULT ? " native" : "",
-                                       mime == NULL ? "" : " mimetype:",
-                                       mime == NULL ? "" : mime);
-
- return 0;
-}
-
-int list_aiprofiles (void) {
- const char * list[1024];
- ssize_t ret;
- ssize_t i;
-
- ret = roar_profiles_list(list, 1024, 0);
-
- if ( ret == -1 ) {
-  fprintf(stderr, "Error: can not read list of profiles\n");
-  return -1;
- }
-
- for (i = 0; i < ret; i++) {
-  printf("profile %" LIBROAR__ll "i:\n", (LIBROAR__longlong signed int)i);
-  show_aiprofile(list[i]);
- }
-
- return 0;
-}
+  printf("Stream direction      : %s\n", roar_dir2str(s.dir));
+  if ( s.pos_rel_id == -1 )
+   printf("Relativ position id   : none (stream not synchronized)\n");
+  else
+   printf("Relativ position id   : %i\n", s.pos_rel_id);
+  printf("Input rate            : %i\n", s.info.rate);
+  printf("Input bits            : %i\n", s.info.bits);
+  printf("Input channels        : %i\n", s.info.channels);
+  printf("Input codec           : %i (%s%s)\n", s.info.codec, roar_codec2str(s.info.codec),
+                                      s.info.codec == ROAR_CODEC_DEFAULT ? " native" : "");
+ }
+
+}
+
 
 int main (int argc, char * argv[]) {
  struct roar_connection con;
- const char * server   = NULL;
- const char * k = NULL;
+ char * server   = NULL;
+ char * k = NULL;
  int    i;
  int    t = 0;
@@ -1212,22 +121,7 @@
 
   if ( strcmp(k, "--server") == 0 ) {
-   ROAR_CKHAVEARGS(1);
-   server = argv[++i];
-  } else if ( strcmp(k, "-v") == 0 || strcmp(k, "--verbose") == 0 ) {
-   g_verbose++;
+   server = k;
   } else if ( strcmp(k, "--help") == 0 ) {
    usage();
-   return 0;
-  } else if ( strcmp(k, "--list-aiprofiles") == 0 ) {
-   list_aiprofiles();
-   return 0;
-  } else if ( strcmp(k, "--list-libstandards") == 0 ) {
-   lib_standards();
-   return 0;
-  } else if ( strcmp(k, "--enum-servers") == 0 ) {
-   enum_servers();
-   return 0;
-  } else if ( strcmp(k, "--hash-password") == 0 ) {
-   hash_password();
    return 0;
   } else if ( *k == '-' ) {
@@ -1242,7 +136,11 @@
  // connect
 
- if ( roar_simple_connect(&con, server, "roarctl") == -1 ) {
-  fprintf(stderr, "Error: Can not connect to server: %s: %s(%i)\n",
-          server == NULL ? "(default)" : server, roar_vs_strerr(roar_error), roar_error);
+ if ( roar_connect(&con, server) == -1 ) {
+  fprintf(stderr, "Error: Can not connect to server\n");
+  return 1;
+ }
+
+ if ( roar_identify(&con, "roarctl") == -1 ) {
+  fprintf(stderr, "Error: Can not identify to server\n");
   return 1;
  }
@@ -1262,20 +160,4 @@
    usage();
 
-  } else if ( !strcmp(k, "sleep") ) {
-   ROAR_CKHAVEARGS(1);
-   roar_sleep(atoi(argv[++i]));
-
-  } else if ( !strcmp(k, "ping") ) {
-   ROAR_CKHAVEARGS(1);
-#ifdef ROAR_HAVE_GETTIMEOFDAY
-   if ( ping(&con, atoi(argv[++i])) == -1 ) {
-    fprintf(stderr, "Error: can not ping\n");
-   }
-#else
-    fprintf(stderr, "Error: ping not supported.\n");
-    i++;
-#endif
-  } else if ( !strcmp(k, "servername") ) {
-   printf("Server Name           : %s\n", roar_get_connection_server(&con));
 
   } else if ( !strcmp(k, "standby") || !strcmp(k, "off") ) {
@@ -1293,15 +175,8 @@
 
   } else if ( !strcmp(k, "exit") ) {
-   if ( roar_terminate(&con, 0) == -1 ) {
+   if ( roar_exit(&con) == -1 ) {
     fprintf(stderr, "Error: can not quit server\n");
    } else {
     printf("Server quited\n");
-    break;
-   }
-  } else if ( !strcmp(k, "terminate") ) {
-   if ( roar_terminate(&con, 1) == -1 ) {
-    fprintf(stderr, "Error: can not terminate server\n");
-   } else {
-    printf("Server got asked to quited\n");
     break;
    }
@@ -1319,45 +194,12 @@
    }
 
-  } else if ( !strcmp(k, "whoami") ) {
-   printf("My client ID is: %i\n", roar_get_clientid(&con));
-  } else if ( !strcmp(k, "beep") ) {
-   roar_beep(&con, NULL);
-  } else if ( !strcmp(k, "serverinfo") ) {
-   server_info(&con);
-  } else if ( !strcmp(k, "libinfo") ) {
-   server_info(NULL);
-  } else if ( !strcmp(k, "servertime") ) {
-   server_time(&con);
   } else if ( !strcmp(k, "serveroinfo") ) {
-   server_oinfo(&con, -1);
-  } else if ( !strcmp(k, "serveroinfo2") ) {
-   t = roar_str2dir(argv[++i]);
-   if ( t == -1 ) {
-    fprintf(stderr, "Error: unknown stream direction: %s\n", argv[i]);
-   } else {
-    server_oinfo(&con, t);
-   }
-  } else if ( !strcmp(k, "serverstandards") ) {
-   server_standards(&con);
-  } else if ( !strcmp(k, "libstandards") ) {
-   lib_standards();
+   server_oinfo(&con);
   } else if ( !strcmp(k, "listclients") ) {
    list_clients(&con);
-  } else if ( !strcmp(k, "clientinfo") ) {
-   ROAR_CKHAVEARGS(1);
-   display_client(&con, atoi(argv[++i]));
   } else if ( !strcmp(k, "liststreams") ) {
    list_streams(&con);
-  } else if ( !strcmp(k, "streaminfo") ) {
-   ROAR_CKHAVEARGS(1);
-   display_stream(&con, atoi(argv[++i]));
   } else if ( !strcmp(k, "allinfo") ) {
-   server_info(&con);
-   printf("\n");
-   server_time(&con);
-   printf("\n");
-   server_standards(&con);
-   printf("\n");
-   server_oinfo(&con, -1);
+   server_oinfo(&con);
    printf("\n");
    list_clients(&con);
@@ -1366,7 +208,14 @@
 
   } else if ( !strcmp(k, "kick") ) {
-   ROAR_CKHAVEARGS(2);
-   t = roar_str2ot((k = argv[++i]));
-   if ( t == -1 ) {
+   k = argv[++i];
+   if ( !strcmp(k, "client") ) {
+    t = ROAR_OT_CLIENT;
+   } else if ( !strcmp(k, "stream") ) {
+    t = ROAR_OT_STREAM;
+   } else if ( !strcmp(k, "sample") ) {
+    t = ROAR_OT_SAMPLE;
+   } else if ( !strcmp(k, "source") ) {
+    t = ROAR_OT_SOURCE;
+   } else {
     fprintf(stderr, "Error: unknown type: %s\n", k);
     continue;
@@ -1379,114 +228,4 @@
    }
 
-  } else if ( !strcmp(k, "newvirtual") ) {
-   ROAR_CKHAVEARGS(6);
-   if ( newvirtual(&con, argv[i+1], argv[i+2], argv[i+3], argv[i+4], argv[i+5], argv[i+6]) == -1 ) {
-    fprintf(stderr, "Error: can not create new virtual stream\n");
-   } else {
-    printf("virtual stream created\n");
-   }
-   i += 6;
-
-  } else if ( !strcmp(k, "volume") ) {
-   ROAR_CKHAVEARGS(2); /* we may need more, but this is the minimum */
-   if ( set_mixer(&con, &i, argc, argv) == -1 ) {
-    fprintf(stderr, "Error: can not set volume\n");
-   } else {
-    printf("volume changed\n");
-   }
-
-  } else if ( !strcmp(k, "flag") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( set_flags(&con, atoi(argv[i]), ROAR_SET_FLAG, argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not set flags\n");
-   } else {
-    printf("flags changed\n");
-   }
-   i++;
-  } else if ( !strcmp(k, "unflag") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( set_flags(&con, atoi(argv[i]), ROAR_RESET_FLAG, argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not reset flags\n");
-   } else {
-    printf("flags changed\n");
-   }
-   i++;
-  } else if ( !strcmp(k, "toggleflag") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( set_flags(&con, atoi(argv[i]), ROAR_TOGGLE_FLAG, argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not toggle flags\n");
-   } else {
-    printf("flags changed\n");
-   }
-   i++;
-  } else if ( !strcmp(k, "protectflag") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( set_flags(&con, atoi(argv[i]), ROAR_NOOP_FLAG|ROAR_PROTECT_FLAG, argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not protect flags\n");
-   } else {
-    printf("flags protected\n");
-   }
-   i++;
-
-  } else if ( !strcmp(k, "role") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( set_role(&con, atoi(argv[i]), roar_str2role(argv[i+1])) == -1 ) {
-    fprintf(stderr, "Error: can not set stream role\n");
-   } else {
-    printf("stream role set\n");
-   }
-   i++;
-
-  } else if ( !strcmp(k, "metaset") ) {
-   ROAR_CKHAVEARGS(4);
-   i++;
-   if ( set_meta(&con, atoi(argv[i]), argv[i+1], argv[i+2], argv[i+3]) == -1 ) {
-    fprintf(stderr, "Error: can not set meta data\n");
-   } else {
-    printf("meta data changed\n");
-   }
-   i += 3;
-  } else if ( !strcmp(k, "metaget") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( show_meta_type(&con, atoi(argv[i]), argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not get meta data\n");
-   }
-   i++;
-  } else if ( !strcmp(k, "metasave") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( save_meta(&con, atoi(argv[i]), argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not get meta data\n");
-   } else {
-    printf("meta data saved\n");
-   }
-   i++;
-  } else if ( !strcmp(k, "metaload") ) {
-   ROAR_CKHAVEARGS(2);
-   i++;
-   if ( load_meta(&con, atoi(argv[i]), argv[i+1]) == -1 ) {
-    fprintf(stderr, "Error: can not set meta data\n");
-   } else {
-    printf("meta data saved\n");
-   }
-   i++;
-
-
-  } else if ( !strcmp(k, "listaiprofiles") || !strcmp(k, "listprofiles") ) {
-   if ( list_aiprofiles() == -1 ) {
-    fprintf(stderr, "Error: can not list profiles\n");
-   }
-  } else if ( !strcmp(k, "aiprofileget") || !strcmp(k, "profileget") ) {
-   ROAR_CKHAVEARGS(1);
-   i++;
-   if ( show_aiprofile(argv[i]) == -1 ) {
-    fprintf(stderr, "Error: can not get profile data\n");
-   }
   } else {
    fprintf(stderr, "Error: invalid command: %s\n", k);
